/* GCC */

#include <fstream>
#include <sstream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

struct Point2
{
    long X, Y;
};

struct Point3
{
    long X, Y, Z;
};

long D, N;
vector<Point3> points3;
vector<Point2> points2;
long long ans1, ans2;

inline bool AllOnOne()
{
    points2.resize(N);

    for(int i = 1; i < N; i++)
    {
        if(points3[i].X != points3[0].X)
            break;
        if(i == N-1)
        {
            for(int j = 0; j < N; j++)
            {
                points2[j].X = points3[j].Z;
                points2[j].Y = points3[j].Y;
            }
            return true;
        }
    }

    for(int i = 1; i < N; i++)
    {
        if(points3[i].Y != points3[0].Y)
            break;
        if(i == N-1)
        {
            for(int j = 0; j < N; j++)
            {
                points2[j].X = points3[j].X;
                points2[j].Y = points3[j].Z;
            }
            return true;
        }
    }

    for(int i = 1; i < N; i++)
    {
        if(points3[i].Z != points3[0].Z)
            break;
        if(i == N-1)
        {
            for(int j = 0; j < N; j++)
            {
                points2[j].X = points3[j].X;
                points2[j].Y = points3[j].Y;
            }
            return true;
        }
    }

    return false;
}

inline void Input()
{
    stringstream ss;
    ifstream fin("cubesurf.in");
    ss<<fin.rdbuf();
    fin.close();

    ss>>D>>N;
    points3.resize(N);

    for(int i = 0; i < N; i++)
        ss>>points3[i].X>>points3[i].Y>>points3[i].Z;
}

inline long long double leng(Point2 p1, Point2 p2)
{
    long long double d = sqrt((p2.X-p1.X)*(p2.X-p1.X) + (p2.Y-p1.Y)*(p2.Y-p1.Y));
    return d;
}

inline long long double sqr(Point2 p1, Point2 p2, Point2 p3)
{
    double l1 = leng(p2, p1), l2 = leng(p3, p2), l3 = leng(p3, p1);
    double p = (l1+l2+l3)/2;

    return sqrt(p*(p-l1)*(p-l2)*(p-l3));
}

inline long long Round(long long double d)
{
    long long tmp = (long long)d;
    return -1*(tmp-d) > tmp + 1 - d ? tmp + 1 : tmp;
}

inline void SolveOnOne()
{
    long long double sum = 0;
    for(int i = 1; i < N-1; i++)
        sum += 2*(long long double)sqr(points2[0], points2[i], points2[i+1]);
    ans1 = Round(sum);
    ans2 = D*D*12 - ans1;
    if(ans2 < ans1)
    {
        long long tmp = ans1;
        ans1 = ans2;
        ans2 = tmp;
    }
}

inline void SolveOnMany()
{
    long long sum = 0ll;
    for(int i = 0; i < N; i++)
        sum += points3[i].X + points3[i].Y + points3[i].Z;
    ans1 = sum;
    ans2 = D*D*12 - ans1;
    if(ans2 < ans1)
    {
        long long tmp = ans1;
        ans1 = ans2;
        ans2 = tmp;
    }
}

int main()
{
    Input();

    if(AllOnOne())
        SolveOnOne();
    else
        SolveOnMany();

    ofstream fout("cubesurf.out");
    fout<<ans1<<' '<<ans2<<endl;
    fout.close();

    return 0;
}
